#ifndef IPAR_H
#define IPAR_H
/*
   === definitions for command definition and decoding ====================

   Copyright  (C) 1992-1997 M.Kraemer, D-64283 Darmstadt, Hoelgesstr. 16,
                             all rights reserved

   $Log: ipar.h,v $
   Revision 1.3  2001/02/23 16:42:31  kraemer
   prototype bug fixed

   Revision 1.2  2000/04/03 12:38:25  kraemer
   from MC


 *
*/

#ifndef U_U_H
#include "u.h"
#endif
#ifndef M_BTREE_H
#include "btree.h"
#endif
/*
   --- Definitions for the IPAR subsystem ----------------------------------
*/
struct SIPAR {
   struct Node ln;
   unsigned long lFlag;
   long lType;                      /* data type */  
   long lDataSize;                  /* size of data element */
   char *cComment;
   void *pv;                        /* ptr. to data */
   struct SBTREEARRAY sBTA;
};
                                      /* some action flags */
#define IPAR_ZEROES   0x00000001
#define IPAR_READONLY 0x00000002
#define IPAR_DYNAMIC  0x00000004
#define IPAR_NOVALUES 0x00000010
#define IPAR_LISTONLY 0x00000020

#define IPAR_DEBUG    0x80000000
                                      /* parameter types */
enum { IPAR_BOOL, IPAR_SHORT, IPAR_LONG, IPAR_FLOAT, IPAR_DOUBLE };

#define ERRCMD_IPARSYS          -1
#define ERRCMD_IPARINVTYPE      -2  /* invalid parameter data type */
#define ERRCMD_IPARINVPTR       -3  /* invalid pointer */
#define ERRCMD_IPARINVNAME      -4  /* invalid parameter name */
#define ERRCMD_IPARNOTFOUND     -5  /* parameter not found */
#define ERRCMD_IPARSTATIC       -6  /* can't delete a static */
#define ERRCMD_IPARREADONLY     -7  /* can't delete a readonly */
#define ERRCMD_IPARINVSUB       -8  /* invalid subscripts */
#define ERRCMD_IPARINVINIT      -9  /* invalid initializer */
#define ERRCMD_IPAREXISTS      -10  /*  */
#define ERRCMD_IPARINVDIM      -11  /* invalid dimension */
#define ERRCMD_IPARPARNOTYET   -12  /*  */
#define ERRCMD_IPARCMDNOTYET   -13  /*  */
#define ERRCMD_IPARATTRNOMATCH -14
#define ERRCMD_IPARFILESYNTAX  -15

void _iparcmd(
              const char *, const char *,
              long *, long *, long *, long *,
              const char *, const char *, const char *,
              const char *,
              long *, long *, long *, long *,
              long * );
void _iparcnst( long *, long *, long * );
void _ipardcl( const char *, 
               const char *, const char *, const char *, 
	       long *, long * );
void _ipargd( char *, char *, char *, long *,
              char *, char *, char *, char *, char *, char *,
              char *, char *, char *, long * );
void _iparop( const char *, long *, long * );

                                 /* internal routines */
int _iparval( struct SIPAR *, const char *, unsigned long );
int _iparfr ( struct SIPAR *, unsigned long );
int _ipardel(   const char *, unsigned long );
int _iparlst(   const char *, unsigned long );
struct SIPAR *_iparptr( const char *, unsigned long, int * );
void *_ipar( const char * );
struct SIPAR *_ipardef( const char *, const char *, const char *, const char *,
                        unsigned long, int *);
int _iparwr( const char *, FILE *, unsigned long );
int _iparrd( const char *, void *, unsigned long );
void _iparfmt( struct SIPAR *, void **, int, struct SBTREEDIM [], FILE *, unsigned long );

void _iparemsg( const char *, int );

#endif
