#ifndef TRXMMAP_H
#define TRXMMAP_H
/*
   Definitions for file/memory mapping services

   Copyright  1998-2000 M.Kraemer, GSI, D-64291 Darmstadt

   $Log: trxmmap.h,v $
   Revision 1.2  2002/11/25 16:29:20  kraemer
   *** empty log message ***

   Revision 1.1  2001/01/09 14:54:34  kraemer
   *** empty log message ***


*/

#include <sys/types.h>
#include <sys/stat.h>

#if defined(AMIGA)
#include <dos.h>
#include <proto/exec.h>
#include <exec/memory.h>

#elif defined(__EMX__)
#include <fcntl.h>
#else

#include <sys/mman.h>
//#if defined(__mips) || defined(sun)
//#define MAP_FILE MAP_RENAME
//#endif

#include <fcntl.h>

#endif

#include "u.h"
#include "cmderr.h"

/*
   --- 
*/
                                      /* */
struct STRXMMAP {

#if defined(AMIGA)
   BPTR psFL;
   BPTR fh;                           /* file handle */
   struct FileInfoBlock sFIB;
   long lAccess;                      /* remember read/write access */
#elif defined(__EMX__)
   FILELOCK fl;
   HFILE fh;
   FILESTATUS3 fs3;
   long lAccess;                      /* remember read/write access */
#endif
   unsigned long ulFileSize;        
   int iFile;                         /* file descriptor for memory mapping */ 
   char *pcFileName;                  /* copy of file name */    
   void *pv;                          /* ptr. to mapped memory */
   struct stat sStat;                 /* file stat */ 

};

#define TRXMMAP_WRITE  0x00000001     /* file open for write */

#define TRXMMAP_DEBUG  0x80000000     /* general check flag */
#define TRXMMAP_QUIET  0x10000000     /* suppress error messages */
#define TRXMMAP_NOMSG  TRXMMAP_QUIET

                                      /* function prototypes */
int TRXMMapClose  ( struct STRXMMAP *, unsigned long );
int TRXMMapDelete ( struct STRXMMAP *, unsigned long );
int TRXMMapInit   ( struct STRXMMAP *, unsigned long );
int TRXMMapInspect( struct STRXMMAP *, unsigned long );
int TRXMMapIsFileMapped( struct STRXMMAP *, const char *, unsigned long );
int TRXMMapIsValid( struct STRXMMAP *, unsigned long );
int TRXMMapRead   ( struct STRXMMAP *, const char *, unsigned long );
int TRXMMapWrite  ( struct STRXMMAP *, const char *, unsigned long, unsigned long );

struct STRXMMAP *_TRXMMapTest( unsigned long );

int TRXCmdMMapTest(
                    const char *, long *
                  );
/*
   --- error codes
*/

int TRXMMapError  ( struct SCMDERR *, unsigned long );

enum { ERRTRXMMAP_SYS=1, ERRTRXMMAP_BADADDR,
       ERRTRXMMAP_BADFILE,
       ERRTRXMMAP_BADMEMORY,
       ERRTRXMMAP_FILENOTMAPPED,
       ERRTRXMMAP_BADFILESIZE, 
       ERRTRXMMAP_BADFILENAME, 
};

#endif
